var addCopyCodeButtonsCallback = function(){
    var elements = document.getElementsByClassName('copy-code-block');

    for (var i = 0; i < elements.length; i++) {
        for (var j = 0; j < elements[i].childNodes.length; j++) {
            if (elements[i].childNodes[j].className === "highlight") {
                var copyButtonContainer = document.createElement("div");
                copyButtonContainer.style = "display: flex; flex-direction: row-reverse";
                
                var copyButton = document.createElement("button");
                copyButton.classList.add("btn", "btn-neutral", "copy-code-button")
                copyButton.innerText = "Copy "

                var copyIcon = document.createElement("span");
                copyIcon.classList.add("fa", "fa-clipboard");

                copyButton.appendChild(copyIcon);
                copyButtonContainer.appendChild(copyButton);
                elements[i].childNodes[j].insertBefore(copyButtonContainer, elements[i].childNodes[j].childNodes[0]);
            }
        }
    }

    new Clipboard('.copy-code-button', {
        text: function(trigger) {
            return trigger.parentElement.parentElement.getElementsByTagName("pre")[0].innerText;
        }
    });
};

if (document.readyState === "complete" || (document.readyState !== "loading" && !document.documentElement.doScroll)) {
    addCopyCodeButtonsCallback();
} else {
    document.addEventListener("DOMContentLoaded", addCopyCodeButtonsCallback);
}